Package com.enonic.xp.admin.widget

## Class WidgetDescriptor

- java.lang.Object
- - com.enonic.xp.descriptor.Descriptor
  - - com.enonic.xp.admin.widget.WidgetDescriptor

-     @PublicApi
      public class WidgetDescriptor
      extends Descriptor

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `WidgetDescriptor.Builder` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static WidgetDescriptor.Builder` | `create()` |
    `PrincipalKeys` | `getAllowedPrincipals()` |
    `Map<String,​String>` | `getConfig()` |
    `String` | `getDescription()` |
    `String` | `getDescriptionI18nKey()` |
    `String` | `getDisplayName()` |
    `String` | `getDisplayNameI18nKey()` |
    `Icon` | `getIcon()` |
    `Set<String>` | `getInterfaces()` |
    `String` | `getKeyString()` |
    `String` | `getUrl()` |
    `boolean` | `hasInterface​(String interfaceName)` |
    `boolean` | `isAccessAllowed​(PrincipalKeys principalKeys)` |

    - ### Methods inherited from class com.enonic.xp.descriptor.Descriptor

      `getApplicationKey, getKey, getName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getUrl

          public String getUrl()

    - #### getKeyString

          public String getKeyString()

    - #### getDisplayName

          public String getDisplayName()

    - #### getDisplayNameI18nKey

          public String getDisplayNameI18nKey()

    - #### getDescription

          public String getDescription()

    - #### getDescriptionI18nKey

          public String getDescriptionI18nKey()

    - #### getIcon

          public Icon getIcon()

    - #### getInterfaces

          public Set<String> getInterfaces()

    - #### hasInterface

          public boolean hasInterface​(String interfaceName)

    - #### getAllowedPrincipals

          public PrincipalKeys getAllowedPrincipals()

    - #### isAccessAllowed

          public boolean isAccessAllowed​(PrincipalKeys principalKeys)

    - #### getConfig

          public Map<String,​String> getConfig()

    - #### create

          public static WidgetDescriptor.Builder create()